import cv2
import numpy as np
from matplotlib import pyplot as plt
#Capturing video 
#cap = cv2.VideoCapture(1)
#cap = cv2.VideoCapture('Resources/sim2_realtime.mp4')
#cap = cv2.VideoCapture('Resources/remora_new_edited_0.25x.mp4')
cap = cv2.VideoCapture('Resources/remora_new_edited_4x.mp4')


while True: 
    _,frame = cap.read()
     # Plotting four circles on the video of the object you want to see the transformation of.
    
    # THESE ARE THE POINTS FOR PERSPECTIVE TRANSFORMATION.
    
    # cv2.circle(frame,(305,230),5,(0,0,255),-1)
    # cv2.circle(frame, (782, 326), 5, (0, 0, 255), -1)
    # cv2.circle(frame, (117, 497), 5, (0, 0, 255), -1)
    # cv2.circle(frame, (895, 615), 5, (0, 0, 255), -1)
    
    
    #cv2.circle(frame, (895, 500), 5, (0, 0, 255), -1)
    # selecting all the above four points in an array
    # Sim2 below
    #imgPts = np.float32([[305,230],[782, 326],[117, 497],[895, 615]])

    #Remora_new_edited below
    #imgPts = np.float32([[683,497],[1337, 500],[360, 877],[1588, 850]])

    #Remora_new_edited higher up in frame below
    imgPts = np.float32([[700,320],[1100, 340],[390, 600],[1170, 611]])
    
    # selecting four points in an array for the destination video( the one you want to see as your output)
    #objPoints = np.float32([[0,0],[420,0],[0,637],[420,637]])

    # Remora below
    objPoints = np.float32([[0,0],[820,0],[0,637],[820,637]])
    #Apply perspective transformation function of openCV2. This function will return the matrix which you can feed into warpPerspective function to get the warped image.
    matrix = cv2.getPerspectiveTransform(imgPts,objPoints)
    draft_result = cv2.warpPerspective(frame,matrix,(640,480))

    # Crop video.
    result = draft_result[0:480, 0:480]
    #Now Plotting both the videos(original, warped video)using matplotlib
    cv2.imshow('frame',frame)
    cv2.imshow('Perspective Transformation', result)

    # How long to wait between each frame. The actual speed of the video will depend on the runtime of the program.
    key = cv2.waitKey(8)
    # plt.imshow(frame)
    plt.show()
    if key == 27:
        break

cap.release()

cv2.destroyAllWindows()